

	TITLE	"EZIP/6502 INFOCOM, INC. --- EQUATES"

	; --------------------------
	; EZIP/6502 2.0
	; Z-CODE INTERPRETER PROGRAM
	; FOR APPLE IIE/IIC
	; --------------------------

	; INFOCOM, INC.
	; 125 CAMBRIDGEPARK DRIVE
	; CAMBRIDGE, MA 02140

	; COMPANY PRIVATE -- NOT FOR DISTRIBUTION

DEBUG	EQU	0		; ASSEMBLY FLAG FOR DEBUGGER (1 = YES)


VERSID	EQU	'H'		; VERSION OF INTERPRETER

	; VERSIONS:
	;
	; C:	TURNING OFF TBL OUTPUT WILL ONLY OCCUR IF TBL OUTPUT IS ON
	;	SO THAT IF THE TBL INFO SUPPLIED WHILE TURNING IT OFF IS NOT
	;	WANTED IT WON'T MESS ANYTHING UP
	;
	;	ALSO, MAKE SHIFT-6 KEY (^) BE INTERPRETED AS UP ARROW KEY ALSO
	;
	; D:	5/26/87 J.D. Arnold
	;	Small fix to make INTBL? work (SBC #2, instead of #1)
	;	6/3/87 J.D. Arnold
	;	Allow the '+' to be used too!
	;
	; E:	6/11/87 J.D. Arnold
	;	make ezip use length of line when putting cursor back into
	;	screen 0 after swapping from status window
	;
	; F:	7/22/87 J.D. Arnold
	;	Don't clear screen after save/restore
	;	Keep input line on screen when scrolling for MORE
	;
	; G: 	7/22/87 J.D. Arnold
	;	Take out JMP to HOME in SAVRES to assure above
	;
	; H:	7/22/87 J.D. Arnold
	;	Put in some CR/LF for RESTORE/SAVE message, cuz they
	;		can't hide behind the CLRSCRN now!
	;

	; -----------
	; ERROR CODES
	; -----------

	; 00 -- INSUFFICIENT RAM
	; 01 -- ILLEGAL X-OP
	; 02 -- ILLEGAL 0-OP
	; 03 -- ILLEGAL 1-OP
	; 04 -- ILLEGAL 2-OP
	; 05 -- Z-STACK UNDERFLOW
	; 06 -- Z-STACK OVERFLOW
	; 07 -- ILLEGAL PROPERTY LENGTH (GETP)
	; 08 -- DIVISION BY ZERO
	; 09 -- ILLEGAL ARGUMENT COUNT (EQUAL?)
	; 10 -- ILLEGAL PROPERTY ID (PUTP)
	; 11 -- ILLEGAL PROPERTY LENGTH (PUTP)
	; 12 -- DISK ADDRESS OUT OF RANGE
	; 13 -- IMPURE CODE TOO LARGE (BM 1/20/86)
	; 14 -- DRIVE ACCESS
	; 15 -- NOT AN EZIP GAME

	INCLUDE 	EQ.ASM

	TITLE 	"ZIP/6502 INFOCOM, INC. --- MACHINE DEPENDENT SHELL"
	INCLUDE 	HARDEQ.ASM

	INCLUDE	RWTS.ASM

	INCLUDE	ZDOS.ASM

	INCLUDE	MACHINE.ASM

	INCLUDE 	COLD.ASM

	TITLE 	"ZIP/6502 INFOCOM, INC. --- INIT & MAINLINE"
	INCLUDE 	WARM.ASM

	INCLUDE 	MAIN.ASM

	INCLUDE 	SUBS.ASM
	INCLUDE 	DISPATCH.ASM

	TITLE 	"ZIP/6502 INFOCOM, INC. --- OPCODE EXECUTORS"
	INCLUDE 	OPS012.ASM
	INCLUDE 	OPSX.ASM
	INCLUDE 	READ.ASM

	TITLE 	"ZIP/6502 INFOCOM, INC. --- OP SUPPORT & MEMORY MANAGEMENT"

	INCLUDE 	XPAGING.ASM

	INCLUDE 	ZSTRING.ASM
	INCLUDE 	OBJECTS.ASM

	TITLE 	"ZIP/6502 INFOCOM, INC. --- MACHINE DEPENDENT SHELL"

	INCLUDE	IO.ASM			; (EZIP SO COLD IS ON 1ST TRACK)

	IF	DEBUG
	INCLUDE	BUGGER.ASM
	ENDIF

	TITLE "ZIP/6502 INFOCOM, INC."
	END

