	PAGE
	STTL "--- MACHINE COLDSTART: CBM128 ---"

	ORG	$1200

	; ---------
	; COLDSTART
	; ---------

COLD1:	LDA	#%00001110	; SET UP CONFIGURATIONS FOR 
	STA	BANK0		; PROPER USE OF MEMORY
	LDA	#%01111111	; SAVING TO BE USED AS NEEDED
	STA	BANK1

	LDA	#$0E
	JSR	CHROUT		; USE UPPER/LOWER CHARS
	LDA	#$80		; PROHIBIT FURTHER
	STA	MODE		; CHARSET CHANGES

	LDA	#0
	JSR	SETMSG		; DISABLE KERNAL MESSAGES
	JSR	CLALL		; CLOSE EVERYTHING

	JMP	WARM1

	; ---------------
	; WARMSTART ENTRY
	; ---------------

SLOAD:	DB	"The story is loading ..."
	DB	EOL
SLOADL	EQU	$-SLOAD

WARM1:	CLD
	LDX	#$FF
	TXS			; RESET MACHINE STACK

	LDA	#CLS		; CLEAR SCREEN, ETC.
	JSR	CHROUT

	LDY	#28		; POSITION "STORY LOADING" MESSAGE
	LDX	#11		; AT (8,11)
	CLC
	JSR	PLOT

	LDX	#<SLOAD
	LDA	#>SLOAD
	LDY	#SLOADL
	JSR	DLINE		; "THE STORY IS LOADING ..."

	LDA	#8		; MAKE BOOT DRIVE
	JSR	DOPEN		; AND OPEN IT

	; FALL THROUGH TO ZIP WARMSTART AT "WARM2"

	END

